#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>

#define all(a) a.begin(), a.end()
#define pb(a) push_back(a)
#define Vec(a) for(auto x : a)cout<<x<<' ';
#define setsp setprecision
using namespace std;
typedef long long ll;
typedef  double ld;
typedef unsigned long long ull;
const ll N = 30000;
vector<ll> Graph[N];
ll dist[N];
bool used[N];
void dfs(ll node, ll k) {
    used[node] = true;
    if (k != 0) {
        for (ll to : Graph[node]) {
            dfs(to, k - 1);
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        Graph[a].pb(b);
        Graph[b].pb(a);
    }
    queue<pair<ll, ll>> q;
    //for (int i = 0; i < n; i++)dist[i] = 0;
    for (int i = 0; i < k; i++) {
        ll p, kek;
        cin >> p >> kek;
        p--;
       // dist[p] = kek;
       q.push(make_pair(p, kek ));
        //dfs(p, kek);
    }
    //cout << 'a' << endl;
    while (!q.empty()) {
        ll x = q.front().first, y = q.front().second;
        q.pop();
        dist[x] == y;
        used[x] = true;
        if (y == 0)continue;
        for (ll to : Graph[x]) {
            if (!used[to] )q.push(make_pair(to, y - 1));
        }
    }
    vector<ll> keker;
    for (int i = 0; i < n; i++) {
        if (used[i])keker.pb(i + 1);

    }
    
    cout << keker.size() << '\n';
    for (int i = 0; i < keker.size(); i++)cout << keker[i] << ' ';
    return 0;
}